ViennaCL - The Vienna Computing Library: viennacl::backend::typesafe_host_array< T, true > Class Template Reference

ViennaCL - The Vienna Computing Library 1.7.1 Free open-source GPU-accelerated linear algebra and solver library. |

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | List of all members
viennacl::backend::typesafe_host_array< T, true > Class Template Reference

Special host array type for conversion between OpenCL types and pure CPU types. More...

`#include <util.hpp>`

## Public Member Functions
| typesafe_host_array ()
| typesafe_host_array (mem_handle const &handle, vcl_size_t num=0)
| ~typesafe_host_array ()
template<typename U >
void | set (vcl_size_t index, U value)
void * | get ()
cpu_type | operator[] (vcl_size_t index) const
vcl_size_t | raw_size () const
vcl_size_t | element_size () const
vcl_size_t | size () const
void | raw_resize (mem_handle const &handle, vcl_size_t num)
| Resize without initializing the new memory. More...
void | resize (mem_handle const &handle, vcl_size_t num)
| Resize including initialization of new memory (cf. std::vector<>) More...

## Detailed Description

### template<typename T>
class viennacl::backend::typesafe_host_array< T, true >

Special host array type for conversion between OpenCL types and pure CPU types.

Definition at line 166 of file util.hpp.

## Constructor & Destructor Documentation

template<typename T >

viennacl::backend::typesafe_host_array< T, true >::typesafe_host_array | ( |  | ) |
| inlineexplicit

Definition at line 172 of file util.hpp.

template<typename T >

viennacl::backend::typesafe_host_array< T, true >::typesafe_host_array | ( | mem_handle const & | handle,
|  | vcl_size_t | num = `0`
| ) |  |
| inlineexplicit

Definition at line 174 of file util.hpp.

template<typename T >

viennacl::backend::typesafe_host_array< T, true >::~typesafe_host_array | ( |  | ) |
| inline

Definition at line 179 of file util.hpp.

## Member Function Documentation

template<typename T >

vcl_size_t viennacl::backend::typesafe_host_array< T, true >::element_size | ( |  | ) | const
| inline

Definition at line 208 of file util.hpp.

template<typename T >

void* viennacl::backend::typesafe_host_array< T, true >::get | ( |  | ) |
| inline

Definition at line 196 of file util.hpp.

template<typename T >

cpu_type viennacl::backend::typesafe_host_array< T, true >::operator[] | ( | vcl_size_t | index | ) | const
| inline

Definition at line 197 of file util.hpp.

template<typename T >

void viennacl::backend::typesafe_host_array< T, true >::raw_resize | ( | mem_handle const & | handle,
|  | vcl_size_t | num
| ) |  |
| inline

Resize without initializing the new memory.

Definition at line 223 of file util.hpp.

template<typename T >

vcl_size_t viennacl::backend::typesafe_host_array< T, true >::raw_size | ( |  | ) | const
| inline

Definition at line 207 of file util.hpp.

template<typename T >

void viennacl::backend::typesafe_host_array< T, true >::resize | ( | mem_handle const & | handle,
|  | vcl_size_t | num
| ) |  |
| inline

Resize including initialization of new memory (cf. std::vector<>)

Definition at line 249 of file util.hpp.

template<typename T >
template<typename U >

void viennacl::backend::typesafe_host_array< T, true >::set | ( | vcl_size_t | index,
|  | U | value
| ) |  |
| inline

Definition at line 186 of file util.hpp.

template<typename T >

vcl_size_t viennacl::backend::typesafe_host_array< T, true >::size | ( |  | ) | const
| inline

Definition at line 216 of file util.hpp.

The documentation for this class was generated from the following file:

- viennacl/backend/util.hpp